// -------------------------------------------------------------------------------
// 
// 		cwCu		AndroidpJava֌Wwb_t@C
// 
// 				Ver 3.18 
// 
// -------------------------------------------------------------------------------

#ifndef __DXJAVAANDROID_H__
#define __DXJAVAANDROID_H__

// CN[h ------------------------------------------------------------------
#include "../DxCompileConfig.h"
#include <android/configuration.h>
#include <android/native_activity.h>

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define JAVAANDR		g_JavaAndroidInfo	

// \̒` --------------------------------------------------------------------

struct DXLIB_JAVA_ANDROID_INFO
{
	int						InitializeFlag ;

	jclass					class_Bitmap ;
	jclass					class_BitmapConfig ;
	jclass					class_Canvas ;
	jclass					class_Typeface ;
	jclass					class_Paint ;
	jclass					class_PaintFontMetrics ;
	jclass					class_TextView ;
	jclass					class_TextView_BufferType ;
	jclass					class_EditText ;
	jclass					class_CharSequence ;
	jclass					class_Dialog ;
	jclass					class_AlertDialog ;
	jclass					class_AlertDialog_Builder ;


	jmethodID				method_Bitmap_createBitmap ;
	jmethodID				method_Bitmap_setPixels ;
	jmethodID				method_Bitmap_getPixels ;
	jmethodID				method_Canvas_newCanvas ;
	jmethodID				method_Canvas_drawText ;
	jmethodID				method_Canvas_drawARGB ;
	jmethodID				method_Typeface_create ;
	jmethodID				method_Paint_newPaint ;
	jmethodID				method_Paint_getFontMetrics ;
	jmethodID				method_Paint_setTextSize ;
	jmethodID				method_Paint_setTypeface ;
	jmethodID				method_Paint_setAntiAlias ;
	jmethodID				method_Paint_setARGB ;
	jmethodID				method_Paint_measureText ;

	jmethodID				method_EditText_newEditText ;
	jmethodID				method_EditText_setText ;
	jmethodID				method_TextView_getText ;
	jmethodID				method_CharSequence_toString ;
	jmethodID				method_Dialog_isShowing ;
	jmethodID				method_AlertDialog_Builder_newAlertDialog_Builder ;
	jmethodID				method_AlertDialog_Builder_setIcon ;
	jmethodID				method_AlertDialog_Builder_setTitle ;
	jmethodID				method_AlertDialog_Builder_setView ;
	jmethodID				method_AlertDialog_Builder_setPositiveButton ;
	jmethodID				method_AlertDialog_Builder_setNegativeButton ;
	jmethodID				method_AlertDialog_Builder_show ;


	jfieldID				field_BitmapConfig_ARGB_8888 ;
	jfieldID				field_PaintFontMetrics_ascent ;
	jfieldID				field_PaintFontMetrics_bottom ;
	jfieldID				field_PaintFontMetrics_descent ;
	jfieldID				field_PaintFontMetrics_leading ;
	jfieldID				field_PaintFontMetrics_top ;
	jfieldID				field_Typeface_NORMAL ;
	jfieldID				field_Typeface_BOLD ;
	jfieldID				field_Typeface_ITALIC ;
	jfieldID				field_Typeface_BOLD_ITALIC ;

	jfieldID				field_TextView_BufferType_EDITABLE ;
	jfieldID				field_TextView_BufferType_NORMAL ;
	jfieldID				field_TextView_BufferType_SPANNABLE ;


	jobject					fieldobject_BitmapConfig_ARGB_8888 ;
	jint					fieldint_Typeface_NORMAL ;
	jint					fieldint_Typeface_BOLD ;
	jint					fieldint_Typeface_ITALIC ;
	jint					fieldint_Typeface_BOLD_ITALIC ;

	jobject					fieldobject_TextView_BufferType_EDITABLE ;
	jobject					fieldobject_TextView_BufferType_NORMAL ;
	jobject					fieldobject_TextView_BufferType_SPANNABLE ;

} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

extern DXLIB_JAVA_ANDROID_INFO g_JavaAndroidInfo ;

// ֐vg^Cv錾-----------------------------------------------------------

// Java ̃NX⃁\bh̎QƂ擾
extern int SetupJavaAndroidInfo( JNIEnv *env ) ;

// Java ̃NX⃁\bh̎QƂ̌n
extern int TerminateJavaAndroidInfo( JNIEnv *env ) ;

// Java ̃NX̃O[oQƂ擾
extern jclass Java_FindClass_Global( JNIEnv *env, const char *name ) ;

// Java ̃X^eBbNIuWFNgtB[h̃O[oQƂ擾
extern jobject Java_GetStaticObjectField_Global( JNIEnv *env, jclass clazz, jfieldID fieldID ) ;

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // __DXJAVAANDROID_H__
